// Code generated by protoc-gen-go. DO NOT EDIT.
// source: mesh/v1alpha1/dataplane.proto

package v1alpha1

import (
	fmt "fmt"
	_ "github.com/envoyproxy/protoc-gen-validate/validate"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// Dataplane defines configuration of a side-car proxy.
type Dataplane struct {
	// Networking describes inbound and outbound interfaces of the dataplane.
	Networking *Dataplane_Networking `protobuf:"bytes,1,opt,name=networking,proto3" json:"networking,omitempty"`
	// Configuration for metrics that should be collected and exposed by the
	// dataplane.
	//
	// Settings defined here will override their respective defaults
	// defined at a Mesh level.
	Metrics              *Metrics `protobuf:"bytes,2,opt,name=metrics,proto3" json:"metrics,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Dataplane) Reset()         { *m = Dataplane{} }
func (m *Dataplane) String() string { return proto.CompactTextString(m) }
func (*Dataplane) ProtoMessage()    {}
func (*Dataplane) Descriptor() ([]byte, []int) {
	return fileDescriptor_7608682fd5ea84a4, []int{0}
}

func (m *Dataplane) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Dataplane.Unmarshal(m, b)
}
func (m *Dataplane) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Dataplane.Marshal(b, m, deterministic)
}
func (m *Dataplane) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Dataplane.Merge(m, src)
}
func (m *Dataplane) XXX_Size() int {
	return xxx_messageInfo_Dataplane.Size(m)
}
func (m *Dataplane) XXX_DiscardUnknown() {
	xxx_messageInfo_Dataplane.DiscardUnknown(m)
}

var xxx_messageInfo_Dataplane proto.InternalMessageInfo

func (m *Dataplane) GetNetworking() *Dataplane_Networking {
	if m != nil {
		return m.Networking
	}
	return nil
}

func (m *Dataplane) GetMetrics() *Metrics {
	if m != nil {
		return m.Metrics
	}
	return nil
}

// Networking describes inbound and outbound interfaces of a dataplane.
type Dataplane_Networking struct {
	// Inbound describes a list of inbound interfaces of the dataplane.
	Inbound []*Dataplane_Networking_Inbound `protobuf:"bytes,1,rep,name=inbound,proto3" json:"inbound,omitempty"`
	// Outbound describes a list of outbound interfaces of the dataplane.
	Outbound []*Dataplane_Networking_Outbound `protobuf:"bytes,2,rep,name=outbound,proto3" json:"outbound,omitempty"`
	// Gateway describes configuration of gateway of the dataplane.
	Gateway *Dataplane_Networking_Gateway `protobuf:"bytes,3,opt,name=gateway,proto3" json:"gateway,omitempty"`
	// TransparentProxying describes configuration for transparent proxying.
	TransparentProxying  *Dataplane_Networking_TransparentProxying `protobuf:"bytes,4,opt,name=transparent_proxying,json=transparentProxying,proto3" json:"transparent_proxying,omitempty"`
	XXX_NoUnkeyedLiteral struct{}                                  `json:"-"`
	XXX_unrecognized     []byte                                    `json:"-"`
	XXX_sizecache        int32                                     `json:"-"`
}

func (m *Dataplane_Networking) Reset()         { *m = Dataplane_Networking{} }
func (m *Dataplane_Networking) String() string { return proto.CompactTextString(m) }
func (*Dataplane_Networking) ProtoMessage()    {}
func (*Dataplane_Networking) Descriptor() ([]byte, []int) {
	return fileDescriptor_7608682fd5ea84a4, []int{0, 0}
}

func (m *Dataplane_Networking) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Dataplane_Networking.Unmarshal(m, b)
}
func (m *Dataplane_Networking) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Dataplane_Networking.Marshal(b, m, deterministic)
}
func (m *Dataplane_Networking) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Dataplane_Networking.Merge(m, src)
}
func (m *Dataplane_Networking) XXX_Size() int {
	return xxx_messageInfo_Dataplane_Networking.Size(m)
}
func (m *Dataplane_Networking) XXX_DiscardUnknown() {
	xxx_messageInfo_Dataplane_Networking.DiscardUnknown(m)
}

var xxx_messageInfo_Dataplane_Networking proto.InternalMessageInfo

func (m *Dataplane_Networking) GetInbound() []*Dataplane_Networking_Inbound {
	if m != nil {
		return m.Inbound
	}
	return nil
}

func (m *Dataplane_Networking) GetOutbound() []*Dataplane_Networking_Outbound {
	if m != nil {
		return m.Outbound
	}
	return nil
}

func (m *Dataplane_Networking) GetGateway() *Dataplane_Networking_Gateway {
	if m != nil {
		return m.Gateway
	}
	return nil
}

func (m *Dataplane_Networking) GetTransparentProxying() *Dataplane_Networking_TransparentProxying {
	if m != nil {
		return m.TransparentProxying
	}
	return nil
}

// Inbound describes a service implemented by the dataplane.
type Dataplane_Networking_Inbound struct {
	// Interface describes networking rules for incoming traffic.
	// The value is a string formatted as
	// <DATAPLANE_IP>:<DATAPLANE_PORT>:<WORKLOAD_PORT>, which means
	// that dataplane must listen on <DATAPLANE_IP>:<DATAPLANE_PORT>
	// and must dispatch to 127.0.0.1:<WORKLOAD_PORT>.
	Interface string `protobuf:"bytes,1,opt,name=interface,proto3" json:"interface,omitempty"`
	// Tags associated with an application this dataplane is deployed next to,
	// e.g. service=web, version=1.0.
	// `service` tag is mandatory.
	Tags                 map[string]string `protobuf:"bytes,2,rep,name=tags,proto3" json:"tags,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	XXX_NoUnkeyedLiteral struct{}          `json:"-"`
	XXX_unrecognized     []byte            `json:"-"`
	XXX_sizecache        int32             `json:"-"`
}

func (m *Dataplane_Networking_Inbound) Reset()         { *m = Dataplane_Networking_Inbound{} }
func (m *Dataplane_Networking_Inbound) String() string { return proto.CompactTextString(m) }
func (*Dataplane_Networking_Inbound) ProtoMessage()    {}
func (*Dataplane_Networking_Inbound) Descriptor() ([]byte, []int) {
	return fileDescriptor_7608682fd5ea84a4, []int{0, 0, 0}
}

func (m *Dataplane_Networking_Inbound) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Dataplane_Networking_Inbound.Unmarshal(m, b)
}
func (m *Dataplane_Networking_Inbound) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Dataplane_Networking_Inbound.Marshal(b, m, deterministic)
}
func (m *Dataplane_Networking_Inbound) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Dataplane_Networking_Inbound.Merge(m, src)
}
func (m *Dataplane_Networking_Inbound) XXX_Size() int {
	return xxx_messageInfo_Dataplane_Networking_Inbound.Size(m)
}
func (m *Dataplane_Networking_Inbound) XXX_DiscardUnknown() {
	xxx_messageInfo_Dataplane_Networking_Inbound.DiscardUnknown(m)
}

var xxx_messageInfo_Dataplane_Networking_Inbound proto.InternalMessageInfo

func (m *Dataplane_Networking_Inbound) GetInterface() string {
	if m != nil {
		return m.Interface
	}
	return ""
}

func (m *Dataplane_Networking_Inbound) GetTags() map[string]string {
	if m != nil {
		return m.Tags
	}
	return nil
}

// Outbound describes a service consumed by the dataplane.
type Dataplane_Networking_Outbound struct {
	// Interface describes networking rules for outgoing traffic.
	// The value is a string formatted as <IP_ADDRESS>:<PORT>,
	// which means that dataplane must listen on <IP_ADDRESS>:<PORT>
	// and must be dispatch to <SERVICE>:<SERVICE_PORT>.
	Interface string `protobuf:"bytes,1,opt,name=interface,proto3" json:"interface,omitempty"`
	// Service name.
	Service string `protobuf:"bytes,2,opt,name=service,proto3" json:"service,omitempty"`
	// Service port.
	ServicePort          uint32   `protobuf:"varint,3,opt,name=service_port,json=servicePort,proto3" json:"service_port,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Dataplane_Networking_Outbound) Reset()         { *m = Dataplane_Networking_Outbound{} }
func (m *Dataplane_Networking_Outbound) String() string { return proto.CompactTextString(m) }
func (*Dataplane_Networking_Outbound) ProtoMessage()    {}
func (*Dataplane_Networking_Outbound) Descriptor() ([]byte, []int) {
	return fileDescriptor_7608682fd5ea84a4, []int{0, 0, 1}
}

func (m *Dataplane_Networking_Outbound) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Dataplane_Networking_Outbound.Unmarshal(m, b)
}
func (m *Dataplane_Networking_Outbound) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Dataplane_Networking_Outbound.Marshal(b, m, deterministic)
}
func (m *Dataplane_Networking_Outbound) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Dataplane_Networking_Outbound.Merge(m, src)
}
func (m *Dataplane_Networking_Outbound) XXX_Size() int {
	return xxx_messageInfo_Dataplane_Networking_Outbound.Size(m)
}
func (m *Dataplane_Networking_Outbound) XXX_DiscardUnknown() {
	xxx_messageInfo_Dataplane_Networking_Outbound.DiscardUnknown(m)
}

var xxx_messageInfo_Dataplane_Networking_Outbound proto.InternalMessageInfo

func (m *Dataplane_Networking_Outbound) GetInterface() string {
	if m != nil {
		return m.Interface
	}
	return ""
}

func (m *Dataplane_Networking_Outbound) GetService() string {
	if m != nil {
		return m.Service
	}
	return ""
}

func (m *Dataplane_Networking_Outbound) GetServicePort() uint32 {
	if m != nil {
		return m.ServicePort
	}
	return 0
}

// Gateway describes a service that ingress should not be proxied.
type Dataplane_Networking_Gateway struct {
	// Tags associated with a gateway (e.g., Kong, Contour, etc) this
	// dataplane is deployed next to, e.g. service=gateway, env=prod.
	// `service` tag is mandatory.
	Tags                 map[string]string `protobuf:"bytes,1,rep,name=tags,proto3" json:"tags,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	XXX_NoUnkeyedLiteral struct{}          `json:"-"`
	XXX_unrecognized     []byte            `json:"-"`
	XXX_sizecache        int32             `json:"-"`
}

func (m *Dataplane_Networking_Gateway) Reset()         { *m = Dataplane_Networking_Gateway{} }
func (m *Dataplane_Networking_Gateway) String() string { return proto.CompactTextString(m) }
func (*Dataplane_Networking_Gateway) ProtoMessage()    {}
func (*Dataplane_Networking_Gateway) Descriptor() ([]byte, []int) {
	return fileDescriptor_7608682fd5ea84a4, []int{0, 0, 2}
}

func (m *Dataplane_Networking_Gateway) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Dataplane_Networking_Gateway.Unmarshal(m, b)
}
func (m *Dataplane_Networking_Gateway) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Dataplane_Networking_Gateway.Marshal(b, m, deterministic)
}
func (m *Dataplane_Networking_Gateway) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Dataplane_Networking_Gateway.Merge(m, src)
}
func (m *Dataplane_Networking_Gateway) XXX_Size() int {
	return xxx_messageInfo_Dataplane_Networking_Gateway.Size(m)
}
func (m *Dataplane_Networking_Gateway) XXX_DiscardUnknown() {
	xxx_messageInfo_Dataplane_Networking_Gateway.DiscardUnknown(m)
}

var xxx_messageInfo_Dataplane_Networking_Gateway proto.InternalMessageInfo

func (m *Dataplane_Networking_Gateway) GetTags() map[string]string {
	if m != nil {
		return m.Tags
	}
	return nil
}

// TransparentProxying describes configuration for transparent proxying.
type Dataplane_Networking_TransparentProxying struct {
	// Port on which all traffic is being transparently redirected.
	RedirectPort         uint32   `protobuf:"varint,1,opt,name=redirect_port,json=redirectPort,proto3" json:"redirect_port,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Dataplane_Networking_TransparentProxying) Reset() {
	*m = Dataplane_Networking_TransparentProxying{}
}
func (m *Dataplane_Networking_TransparentProxying) String() string { return proto.CompactTextString(m) }
func (*Dataplane_Networking_TransparentProxying) ProtoMessage()    {}
func (*Dataplane_Networking_TransparentProxying) Descriptor() ([]byte, []int) {
	return fileDescriptor_7608682fd5ea84a4, []int{0, 0, 3}
}

func (m *Dataplane_Networking_TransparentProxying) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Dataplane_Networking_TransparentProxying.Unmarshal(m, b)
}
func (m *Dataplane_Networking_TransparentProxying) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Dataplane_Networking_TransparentProxying.Marshal(b, m, deterministic)
}
func (m *Dataplane_Networking_TransparentProxying) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Dataplane_Networking_TransparentProxying.Merge(m, src)
}
func (m *Dataplane_Networking_TransparentProxying) XXX_Size() int {
	return xxx_messageInfo_Dataplane_Networking_TransparentProxying.Size(m)
}
func (m *Dataplane_Networking_TransparentProxying) XXX_DiscardUnknown() {
	xxx_messageInfo_Dataplane_Networking_TransparentProxying.DiscardUnknown(m)
}

var xxx_messageInfo_Dataplane_Networking_TransparentProxying proto.InternalMessageInfo

func (m *Dataplane_Networking_TransparentProxying) GetRedirectPort() uint32 {
	if m != nil {
		return m.RedirectPort
	}
	return 0
}

func init() {
	proto.RegisterType((*Dataplane)(nil), "kuma.mesh.v1alpha1.Dataplane")
	proto.RegisterType((*Dataplane_Networking)(nil), "kuma.mesh.v1alpha1.Dataplane.Networking")
	proto.RegisterType((*Dataplane_Networking_Inbound)(nil), "kuma.mesh.v1alpha1.Dataplane.Networking.Inbound")
	proto.RegisterMapType((map[string]string)(nil), "kuma.mesh.v1alpha1.Dataplane.Networking.Inbound.TagsEntry")
	proto.RegisterType((*Dataplane_Networking_Outbound)(nil), "kuma.mesh.v1alpha1.Dataplane.Networking.Outbound")
	proto.RegisterType((*Dataplane_Networking_Gateway)(nil), "kuma.mesh.v1alpha1.Dataplane.Networking.Gateway")
	proto.RegisterMapType((map[string]string)(nil), "kuma.mesh.v1alpha1.Dataplane.Networking.Gateway.TagsEntry")
	proto.RegisterType((*Dataplane_Networking_TransparentProxying)(nil), "kuma.mesh.v1alpha1.Dataplane.Networking.TransparentProxying")
}

func init() { proto.RegisterFile("mesh/v1alpha1/dataplane.proto", fileDescriptor_7608682fd5ea84a4) }

var fileDescriptor_7608682fd5ea84a4 = []byte{
	// 500 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xb4, 0x94, 0x4f, 0x6b, 0x13, 0x41,
	0x18, 0xc6, 0x99, 0x4d, 0x9a, 0xdd, 0x7d, 0xd3, 0x40, 0x99, 0x16, 0x5c, 0xb6, 0x08, 0x45, 0x0f,
	0x86, 0x1e, 0x36, 0x49, 0x45, 0x94, 0xe2, 0x29, 0x28, 0x55, 0xa1, 0x5a, 0x86, 0x9e, 0x7a, 0x29,
	0xd3, 0x64, 0x4c, 0x96, 0x24, 0x33, 0xcb, 0xec, 0x24, 0x35, 0x5f, 0xc1, 0x8f, 0xe0, 0xc1, 0x9b,
	0xdf, 0xc0, 0x93, 0x27, 0x6f, 0x7e, 0x16, 0x3f, 0x45, 0x65, 0xfe, 0x6d, 0x94, 0xf6, 0xb0, 0x3d,
	0x78, 0x9b, 0xe4, 0x7d, 0x9e, 0xdf, 0xbc, 0xcf, 0xfb, 0x0e, 0x0b, 0x0f, 0x17, 0xac, 0x9c, 0xf6,
	0x56, 0x03, 0x3a, 0x2f, 0xa6, 0x74, 0xd0, 0x1b, 0x53, 0x45, 0x8b, 0x39, 0xe5, 0x2c, 0x2b, 0xa4,
	0x50, 0x02, 0xe3, 0xd9, 0x72, 0x41, 0x33, 0xad, 0xc9, 0xbc, 0x26, 0xdd, 0xff, 0xd7, 0xb2, 0x60,
	0x4a, 0xe6, 0xa3, 0xd2, 0x1a, 0xd2, 0x07, 0x2b, 0x3a, 0xcf, 0xc7, 0x54, 0xb1, 0x9e, 0x3f, 0xd8,
	0xc2, 0xa3, 0xef, 0x11, 0xc4, 0xaf, 0x3c, 0x1d, 0xbf, 0x01, 0xe0, 0x4c, 0x5d, 0x0b, 0x39, 0xcb,
	0xf9, 0x24, 0x41, 0x07, 0xa8, 0xdb, 0x3e, 0xea, 0x66, 0xb7, 0x2f, 0xcb, 0x2a, 0x4b, 0xf6, 0xbe,
	0xd2, 0x93, 0xbf, 0xbc, 0xf8, 0x19, 0x84, 0xae, 0x83, 0x24, 0x30, 0x98, 0xfd, 0xbb, 0x30, 0xa7,
	0x56, 0x42, 0xbc, 0x36, 0xfd, 0x16, 0x02, 0x6c, 0x88, 0xf8, 0x1d, 0x84, 0x39, 0xbf, 0x12, 0x4b,
	0x3e, 0x4e, 0xd0, 0x41, 0xa3, 0xdb, 0x3e, 0xea, 0xd7, 0x6d, 0x26, 0x7b, 0x6b, 0x7d, 0xc4, 0x03,
	0xf0, 0x29, 0x44, 0x62, 0xa9, 0x2c, 0x2c, 0x30, 0xb0, 0x41, 0x6d, 0xd8, 0x07, 0x67, 0x24, 0x15,
	0x42, 0xb7, 0x36, 0xa1, 0x8a, 0x5d, 0xd3, 0x75, 0xd2, 0x30, 0x01, 0xeb, 0xb7, 0x76, 0x62, 0x7d,
	0xc4, 0x03, 0xb0, 0x80, 0x3d, 0x25, 0x29, 0x2f, 0x0b, 0x2a, 0x19, 0x57, 0x97, 0x85, 0x14, 0x9f,
	0xd6, 0x7a, 0x01, 0x4d, 0x03, 0x7e, 0x59, 0x1b, 0x7c, 0xbe, 0x81, 0x9c, 0x39, 0x06, 0xd9, 0x55,
	0xb7, 0xff, 0x4c, 0x7f, 0x21, 0x08, 0xdd, 0x80, 0xf0, 0x13, 0x88, 0x73, 0xae, 0x98, 0xfc, 0x48,
	0x47, 0xcc, 0xac, 0x3c, 0x1e, 0xc6, 0x3f, 0x7e, 0xff, 0x6c, 0x34, 0x65, 0xb0, 0x13, 0x90, 0x4d,
	0x0d, 0x5f, 0x40, 0x53, 0xd1, 0x49, 0xe9, 0x86, 0x77, 0x7c, 0xdf, 0x4d, 0x64, 0xe7, 0x74, 0x52,
	0xbe, 0xe6, 0x4a, 0xae, 0x87, 0xa0, 0xf9, 0x5b, 0x5f, 0x50, 0x10, 0x21, 0x62, 0x98, 0xe9, 0x73,
	0x88, 0xab, 0x32, 0xde, 0x81, 0xc6, 0x8c, 0xad, 0x6d, 0x2f, 0x44, 0x1f, 0xf1, 0x1e, 0x6c, 0xad,
	0xe8, 0x7c, 0xc9, 0xcc, 0x5b, 0x8a, 0x89, 0xfd, 0x71, 0x1c, 0xbc, 0x40, 0xe9, 0x67, 0x04, 0x91,
	0xdf, 0x4e, 0xfd, 0x28, 0x8f, 0x21, 0x2c, 0x99, 0x5c, 0xe5, 0x23, 0x47, 0xac, 0x64, 0x53, 0x44,
	0x7c, 0x05, 0xf7, 0x61, 0xdb, 0x1d, 0x2f, 0x0b, 0x21, 0x95, 0x59, 0x73, 0x67, 0xd8, 0xd1, 0xca,
	0xe8, 0xb0, 0x95, 0xdc, 0xdc, 0x34, 0xba, 0x88, 0xb4, 0x9d, 0xe4, 0x4c, 0x48, 0x95, 0x7e, 0x45,
	0x10, 0xba, 0xe5, 0x56, 0xd3, 0x42, 0xf7, 0x9c, 0x96, 0xf3, 0xff, 0x9f, 0x69, 0x9d, 0xc0, 0xee,
	0x1d, 0x6f, 0x04, 0xf7, 0xa1, 0x23, 0xd9, 0x38, 0x97, 0x6c, 0xa4, 0x6c, 0x54, 0x64, 0xa2, 0xb6,
	0xf5, 0xc5, 0xad, 0xc3, 0xa6, 0x8e, 0x4a, 0xb6, 0xbd, 0x42, 0x27, 0x1d, 0xc2, 0x45, 0xe4, 0x63,
	0x5c, 0xb5, 0xcc, 0x97, 0xe4, 0xe9, 0x9f, 0x00, 0x00, 0x00, 0xff, 0xff, 0x34, 0x1f, 0xc2, 0xdc,
	0xb4, 0x04, 0x00, 0x00,
}
