package mesh

import (
	"github.com/Kong/kuma/pkg/core/validators"
)

func (d *TrafficPermissionResource) Validate() error {
	var err validators.ValidationError
	err.Add(d.validateSources())
	err.Add(d.validateDestinations())
	return err.OrNil()
}

func (d *TrafficPermissionResource) validateSources() validators.ValidationError {
	return ValidateSelectors(validators.RootedAt("sources"), d.Spec.Sources, OnlyServiceTagAllowed)
}

func (d *TrafficPermissionResource) validateDestinations() (err validators.ValidationError) {
	return ValidateSelectors(validators.RootedAt("destinations"), d.Spec.Destinations, OnlyServiceTagAllowed)
}
